--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/peripheral/eth.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/peripheral/eth.c	2015-08-06 17:17:34.924148000 +0800
@@ -0,0 +1,910 @@
+#include <linux/module.h>
+#include <linux/platform_device.h>
+
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/ethtool.h>
+#include <linux/mii.h>
+
+#include <linux/interrupt.h>
+#include <linux/dma-mapping.h>
+#include <linux/spinlock.h>
+#include <linux/delay.h>
+#include <linux/crc32.h>
+#include <asm/cacheflush.h>
+
+#include <linux/seq_file.h>
+#include <linux/proc_fs.h>
+
+#include "mach/cnc1900_power_clk.h"
+
+#define	ETH_CFG_ADDR		    0x0800
+#define	ETH_INT_REG_ADDR        0x0840
+#define	ETH_INT_ENB_ADDR        0x0844
+#define	ETH_INT_SET_ADDR        0x0848
+#define	ETH_INT_CLS_ADDR        0x084C
+
+#define	ETH_TX_DMA_ADDR        	(priv->ctl_offset + 0x09C0)
+#define	ETH_TX_STAT_ADDR     	(priv->ctl_offset + 0x09C4)
+#define	ETH_RX_BASE_ADDR       	(priv->ctl_offset + 0x09C8)
+#define	ETH_RX_CFG_ADDR        	(priv->ctl_offset + 0x09CC)
+#define	ETH_RX_RD_ADDR         	(priv->ctl_offset + 0x09D0)
+#define	ETH_RX_WR_ADDR         	(priv->ctl_offset + 0x09D4)
+#define	ETH_RX_STAT_ADDR     	(priv->ctl_offset + 0x09DC)
+
+#define	ETH_MAC_CFG0          	(priv->mac_offset + 0x0A40)
+#define	ETH_MAC_CFG1          	(priv->mac_offset + 0x0A44)
+#define	ETH_MAC_IPGT          	(priv->mac_offset + 0x0A48)
+#define	ETH_MAC_IPGR          	(priv->mac_offset + 0x0A4C)
+#define	ETH_MAC_CLRT          	(priv->mac_offset + 0x0A50)
+#define	ETH_MAC_MAXF          	(priv->mac_offset + 0x0A54)
+#define	ETH_MAC_SUPP          	(priv->mac_offset + 0x0A58)
+#define	ETH_MAC_TEST          	(priv->mac_offset + 0x0A5C)
+#define	ETH_MAC_MCFG          	(0x0A60)
+#define	ETH_MAC_MCMD          	(0x0A64)
+#define	ETH_MAC_MADR          	(0x0A68)
+#define	ETH_MAC_MWTD          	(0x0A6C)
+#define	ETH_MAC_MRDD          	(0x0A70)
+#define	ETH_MAC_MIND          	(0x0A74)
+#define	ETH_MAC_SA0           	(priv->mac_offset + 0x0A80)
+#define	ETH_MAC_SA1           	(priv->mac_offset + 0x0A84)
+#define	ETH_MAC_SA2           	(priv->mac_offset + 0x0A88)
+#define	ETH_MAC_TSV0           	(priv->mac_offset + 0x0A8C)
+#define	ETH_MAC_TSV1           	(priv->mac_offset + 0x0A90)
+#define	ETH_MAC_RSV            	(priv->mac_offset + 0x0A94)
+#define	ETH_MAC_SA_MASK        	(priv->mac_offset + 0x0A98)
+#define	ETH_MAC_HASH_TAB0      	(priv->mac_offset + 0x0A9C)
+#define	ETH_MAC_HASH_TAB1      	(priv->mac_offset + 0x0AA0)
+
+#define	ETH0_CTL_BASE			0x09C0
+#define	ETH0_MAC_BASE			0x0A40
+#define	ETH1_CTL_BASE			0x0A00
+#define	ETH1_MAC_BASE			0x0AC0
+
+#define ETH_INT_TX		(0x01 << priv->shift)
+#define ETH_INT_RX		(0x02 << priv->shift)
+#define ETH_INT_HALF	(0x04 << priv->shift)
+#define ETH_INT_MASK	(0x07 << priv->shift)
+
+#define ETH_FIFO_TOG		0x80000000
+#define ETH_FIFO_EMPTY		0x40000000
+#define ETH_FIFO_MASK		0x00000FFF
+
+#define RX_ITEM_SIZE 	1544
+#define RX_ITEM_MAX 	255
+#define TX_ITEM_SIZE	1552
+
+#define DEBUG(...)
+//#define DEBUG printk
+
+struct tx_desc
+{
+	volatile u32 buffer_addr;
+	volatile u32 buffer_len;
+	volatile u32 next_link_item;
+	volatile u32 next_item_valid_flag;
+};
+
+struct rx_unit
+{
+	volatile u32 reserved;
+	volatile u32 size;
+	u8 packet[4];
+};
+
+struct cn100_private
+{
+	void __iomem *iomem;
+	struct net_device *netdev;
+
+	struct napi_struct napi;
+
+	spinlock_t tx_lock;
+	spinlock_t rx_lock;
+
+	spinlock_t lock;
+	struct mii_if_info mii;
+	struct timer_list timer;
+
+	/* RX and TX Buffer Info */
+
+	int shift;
+	int ctl_offset;
+	int mac_offset;
+
+	int dma_size;
+	dma_addr_t dma_addr;
+	void __iomem *dma_area;
+
+	dma_addr_t tx_desc_addr;
+	void __iomem *tx_data_area;
+	struct tx_desc *tx_desc_p;
+
+	dma_addr_t rx_fifo_addr;
+	struct rx_unit *rx_fifo_p[RX_ITEM_MAX];
+	int rx_fifo_num;
+};
+
+/*
+ * SQOS hook handling functionality
+ * sqos submodule in Purevu driver will register hook handlers
+ * net drivers will call hook functions if they are non-null
+ */
+typedef int ( *pfn_cvm_on_before_skb_tx )           ( struct net_device* net_dev, struct sk_buff *skb );
+typedef int ( *pfn_cvm_on_skb_tx_done )             ( struct net_device* net_dev, struct sk_buff *skb );
+typedef int ( *pfn_cvm_on_skb_dropped )             ( struct net_device* net_dev, struct sk_buff *skb );
+typedef int ( *pfn_cvm_on_tx_rate_limit_changed )   ( struct net_device* net_dev, int worst_stream_rate_in_mbps, int combined_stream_rate_in_mbps, int worst_stream_udp_rate_in_mbps, int combined_stream_udp_rate_in_mbps );
+typedef int ( *pfn_cvm_on_tx_skb_cloned )           ( struct net_device* net_dev, struct sk_buff *skb, struct sk_buff* new_skb );
+
+/*
+ * Before sk_buff is put on ip transmit queue
+ */
+pfn_cvm_on_before_skb_tx cvm_on_before_skb_tx_ip;
+
+/*
+ * Before sk_buff is put on device transmit queue
+ */
+pfn_cvm_on_before_skb_tx cvm_on_before_skb_tx;
+
+/*
+ * After device is done transmitting sk_buff
+ */
+pfn_cvm_on_skb_tx_done cvm_on_skb_tx_done;
+
+/*
+ * If the device drops sk_buff
+ */
+pfn_cvm_on_skb_dropped cvm_on_skb_dropped;
+
+/*
+ * When tx_rate changes,
+ * device has to provide
+ * 1) worst tx rate and corresponding udp rate in case of multiple connections
+ * 2) maximum tx rate which will support all connections simultaneously
+ *
+ * eg. in wifi ap with 2 stations connected at sta1( 24mbps ), sta2 ( 54 mbps )
+ * if max supported rate of ap is 54
+ * worst tx rate will be 24
+ * combined tx rate can probably be weighted average of 24 and 54
+ * since ap's max rate is 54, it is being shared by sta1 and sta 2
+ *
+ */
+pfn_cvm_on_tx_rate_limit_changed cvm_on_tx_rate_limit_changed;
+
+/*
+ * if the device clones original sk_buff
+ */
+pfn_cvm_on_tx_skb_cloned cvm_on_tx_skb_cloned;
+
+EXPORT_SYMBOL( cvm_on_before_skb_tx_ip );
+EXPORT_SYMBOL( cvm_on_before_skb_tx );
+EXPORT_SYMBOL( cvm_on_skb_tx_done );
+EXPORT_SYMBOL( cvm_on_skb_dropped );
+EXPORT_SYMBOL( cvm_on_tx_rate_limit_changed );
+EXPORT_SYMBOL( cvm_on_tx_skb_cloned );
+
+static int show_proc_eth(struct seq_file *m, void *v, int eth)
+{
+	struct {
+		int ctl_offset; int mac_offset;
+	} *priv, priv_offsets[2] = {
+		/* eth0: */ { .ctl_offset = 0, .mac_offset = 0 },
+		/* eth1: */ { .ctl_offset = ETH1_CTL_BASE - ETH0_CTL_BASE, .mac_offset = ETH1_MAC_BASE - ETH0_MAC_BASE }
+	};
+	static void *eth_virt_base_addr = NULL;
+
+	if (eth_virt_base_addr == NULL) {
+		eth_virt_base_addr = ioremap(0xB1400000, 0x1000);
+	}
+
+	if (eth_virt_base_addr == NULL) return -1;
+
+	priv = &priv_offsets[eth]; // priv->... is used in the following macros
+#define READ_ETH(addr) __raw_readl(eth_virt_base_addr + (addr))
+
+	seq_printf(m, "eth%d:\n", eth);
+
+	seq_printf(m, "%08x <= ETH_CFG_ADDR\n", READ_ETH(ETH_CFG_ADDR));
+	seq_printf(m, "%08x <= ETH_INT_REG_ADDR\n", READ_ETH(ETH_INT_REG_ADDR));
+	seq_printf(m, "%08x <= ETH_INT_ENB_ADDR\n", READ_ETH(ETH_INT_ENB_ADDR));
+	seq_printf(m, "%08x <= ETH_INT_SET_ADDR\n", READ_ETH(ETH_INT_SET_ADDR));
+	seq_printf(m, "%08x <= ETH_INT_CLS_ADDR\n", READ_ETH(ETH_INT_CLS_ADDR));
+
+	seq_printf(m, "%08x <= ETH_TX_DMA_ADDR\n", READ_ETH(ETH_TX_DMA_ADDR));
+	seq_printf(m, "%08x <= ETH_TX_STAT_ADDR\n", READ_ETH(ETH_TX_STAT_ADDR));
+	seq_printf(m, "%08x <= ETH_RX_BASE_ADDR\n", READ_ETH(ETH_RX_BASE_ADDR));
+	seq_printf(m, "%08x <= ETH_RX_CFG_ADDR\n", READ_ETH(ETH_RX_CFG_ADDR));
+	seq_printf(m, "%08x <= ETH_RX_RD_ADDR\n", READ_ETH(ETH_RX_RD_ADDR));
+	seq_printf(m, "%08x <= ETH_RX_WR_ADDR\n", READ_ETH(ETH_RX_WR_ADDR));
+	seq_printf(m, "%08x <= ETH_RX_STAT_ADDR\n", READ_ETH(ETH_RX_STAT_ADDR));
+
+	seq_printf(m, "%08x <= ETH_MAC_CFG0\n", READ_ETH(ETH_MAC_CFG0));
+	seq_printf(m, "%08x <= ETH_MAC_CFG1\n", READ_ETH(ETH_MAC_CFG1));
+	seq_printf(m, "%08x <= ETH_MAC_IPGT\n", READ_ETH(ETH_MAC_IPGT));
+	seq_printf(m, "%08x <= ETH_MAC_IPGR\n", READ_ETH(ETH_MAC_IPGR));
+	seq_printf(m, "%08x <= ETH_MAC_CLRT\n", READ_ETH(ETH_MAC_CLRT));
+	seq_printf(m, "%08x <= ETH_MAC_MAXF\n", READ_ETH(ETH_MAC_MAXF));
+	seq_printf(m, "%08x <= ETH_MAC_SUPP\n", READ_ETH(ETH_MAC_SUPP));
+	seq_printf(m, "%08x <= ETH_MAC_TEST\n", READ_ETH(ETH_MAC_TEST));
+	seq_printf(m, "%08x <= ETH_MAC_MCFG\n", READ_ETH(ETH_MAC_MCFG));
+	seq_printf(m, "%08x <= ETH_MAC_MCMD\n", READ_ETH(ETH_MAC_MCMD));
+	seq_printf(m, "%08x <= ETH_MAC_MADR\n", READ_ETH(ETH_MAC_MADR));
+	seq_printf(m, "%08x <= ETH_MAC_MWTD\n", READ_ETH(ETH_MAC_MWTD));
+	seq_printf(m, "%08x <= ETH_MAC_MRDD\n", READ_ETH(ETH_MAC_MRDD));
+	seq_printf(m, "%08x <= ETH_MAC_MIND\n", READ_ETH(ETH_MAC_MIND));
+	seq_printf(m, "%08x <= ETH_MAC_SA0\n", READ_ETH(ETH_MAC_SA0));
+	seq_printf(m, "%08x <= ETH_MAC_SA1\n", READ_ETH(ETH_MAC_SA1));
+	seq_printf(m, "%08x <= ETH_MAC_SA2\n", READ_ETH(ETH_MAC_SA2));
+	seq_printf(m, "%08x <= ETH_MAC_TSV0\n", READ_ETH(ETH_MAC_TSV0));
+	seq_printf(m, "%08x <= ETH_MAC_TSV1\n", READ_ETH(ETH_MAC_TSV1));
+	seq_printf(m, "%08x <= ETH_MAC_RSV\n", READ_ETH(ETH_MAC_RSV));
+	seq_printf(m, "%08x <= ETH_MAC_SA_MASK\n", READ_ETH(ETH_MAC_SA_MASK));
+	seq_printf(m, "%08x <= ETH_MAC_HASH_TAB0\n", READ_ETH(ETH_MAC_HASH_TAB0));
+	seq_printf(m, "%08x <= ETH_MAC_HASH_TAB1\n", READ_ETH(ETH_MAC_HASH_TAB1));
+
+	return 0;
+}
+
+static int show_proc_eth0(struct seq_file *m, void *v)
+{
+	return show_proc_eth(m, v, 0);
+}
+
+static int show_proc_eth1(struct seq_file *m, void *v)
+{
+	return show_proc_eth(m, v, 1);
+}
+
+/**
+ * /proc/eth0 was openned. Use the single_open iterator
+ *
+ * @param inode
+ * @param file
+ * @return
+ */
+static int proc_eth0_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, show_proc_eth0, NULL);
+}
+
+/**
+ * /proc/eth1 was openned. Use the single_open iterator
+ *
+ * @param inode
+ * @param file
+ * @return
+ */
+static int proc_eth1_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, show_proc_eth1, NULL);
+}
+
+static struct file_operations proc_eth0_operations = {
+	.open           = proc_eth0_open,
+	.read           = seq_read,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+static struct file_operations proc_eth1_operations = {
+	.open           = proc_eth1_open,
+	.read           = seq_read,
+	.llseek         = seq_lseek,
+	.release        = single_release,
+};
+
+static int __init eth_proc_init(void)
+{
+	static struct proc_dir_entry *entry;
+	if (entry) return 0;
+
+	entry = create_proc_entry("eth0", 0, NULL);
+	if (entry) {
+		entry->proc_fops = &proc_eth0_operations;
+	}
+	entry = create_proc_entry("eth1", 0, NULL);
+	if (entry) {
+		entry->proc_fops = &proc_eth1_operations;
+	}
+	return 0;
+}
+
+static unsigned char MacAddr[] = {0x00, 0x1A, 0xCC, 0x00, 0x00, 0x00};
+static unsigned char MacAddr1[] = {0x00, 0x1A, 0xCC, 0x00, 0x00, 0x01};
+
+static int netdev_ioctl(struct net_device *dev, struct ifreq *rq, int cmd)
+{
+	struct cn100_private *priv = netdev_priv(dev);
+	int rc;
+
+	if (!netif_running(dev))
+		return -EINVAL;
+
+	spin_lock_irq(&priv->lock);
+	rc = generic_mii_ioctl(&priv->mii, if_mii(rq), cmd, NULL);
+	spin_unlock_irq(&priv->lock);
+	return rc;
+}
+
+static int netdev_get_settings(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct cn100_private *priv = netdev_priv(dev);
+	int rc;
+
+	spin_lock_irq(&priv->lock);
+	rc = mii_ethtool_gset(&priv->mii, cmd);
+	spin_unlock_irq(&priv->lock);
+	return rc;
+}
+
+static int netdev_set_settings(struct net_device *dev, struct ethtool_cmd *cmd)
+{
+	struct cn100_private *priv = netdev_priv(dev);
+	int rc;
+
+	spin_lock_irq(&priv->lock);
+	rc = mii_ethtool_sset(&priv->mii, cmd);
+	spin_unlock_irq(&priv->lock);
+	return rc;
+}
+
+static int netdev_nway_reset(struct net_device *dev)
+{
+	struct cn100_private *priv = netdev_priv(dev);
+	return mii_nway_restart(&priv->mii);
+}
+
+static u32 netdev_get_link(struct net_device *dev)
+{
+	struct cn100_private *priv = netdev_priv(dev);
+	return mii_link_ok(&priv->mii);
+}
+
+static struct ethtool_ops netdev_ethtool_ops = {
+	.get_settings = netdev_get_settings,
+	.set_settings = netdev_set_settings,
+	.nway_reset = netdev_nway_reset,
+	.get_link   = netdev_get_link,
+};
+
+static void cn100_hw_set_addr(unsigned char *MacAddr, struct cn100_private *priv)
+{
+	__raw_writel((MacAddr[1] << 8) | MacAddr[0], priv->iomem + ETH_MAC_SA2);
+	__raw_writel((MacAddr[3] << 8) | MacAddr[2], priv->iomem + ETH_MAC_SA1);
+	__raw_writel((MacAddr[5] << 8) | MacAddr[4], priv->iomem + ETH_MAC_SA0);
+}
+
+static int cn100_set_mac_address(struct net_device *dev, void *addr)
+{
+	struct cn100_private *priv = netdev_priv(dev);
+	int ret = eth_mac_addr(dev, addr);
+	if (ret < 0)
+		return ret;
+
+	/*	memcpy(MacAddr, dev->dev_addr, ETH_ALEN);*/
+	cn100_hw_set_addr(dev->dev_addr, priv);
+	return 0;
+}
+
+static inline void __raw_clearbit(unsigned int mask, volatile void __iomem *addr)
+{
+	unsigned int val = __raw_readl(addr);
+	__raw_writel(val&(~mask), addr);
+}
+
+static void cn100_hw_close(struct cn100_private *priv)
+{
+	__raw_clearbit(ETH_INT_MASK, priv->iomem + ETH_INT_ENB_ADDR);
+	__raw_writel(0x00, priv->iomem + ETH_RX_CFG_ADDR);
+
+	__raw_writel(0x8000, priv->iomem + ETH_MAC_CFG0);
+	udelay(800);
+}
+
+static void cn100_hw_open(struct cn100_private *priv)
+{
+	int full = priv->mii.full_duplex;
+
+	__raw_writel(0x20002000, priv->iomem + ETH_CFG_ADDR);
+
+	__raw_writel(0x0100, priv->iomem + ETH_MAC_SUPP);
+	__raw_writel(full ? 0x00B3 : 0x00B2, priv->iomem + ETH_MAC_CFG1);
+	__raw_writel(0x001C, priv->iomem + ETH_MAC_MCFG);
+	__raw_writel(0x0015, priv->iomem + ETH_MAC_IPGT);
+	__raw_writel(0x0C12, priv->iomem + ETH_MAC_IPGR);
+}
+
+static inline void __raw_setbit(unsigned int mask, volatile void __iomem *addr)
+{
+	unsigned int val = __raw_readl(addr);
+	__raw_writel(val|mask, addr);
+}
+
+static void cn100_hw_start(struct cn100_private *priv)
+{
+	__raw_writel((priv->rx_fifo_addr >> 3), priv->iomem + ETH_RX_BASE_ADDR);
+	__raw_writel((priv->rx_fifo_num << 8) | (RX_ITEM_SIZE >> 3) | 0x80000000, priv->iomem + ETH_RX_CFG_ADDR);
+	__raw_writel(0x00, priv->iomem + ETH_RX_RD_ADDR);
+	__raw_writel(0x00, priv->iomem + ETH_RX_WR_ADDR);
+
+	__raw_writel(0x01, priv->iomem + ETH_MAC_CFG0);
+	__raw_writel(ETH_INT_MASK, priv->iomem + ETH_INT_CLS_ADDR);
+	__raw_setbit(ETH_INT_MASK, priv->iomem + ETH_INT_ENB_ADDR);
+}
+
+static void cn100_hw_tx(struct cn100_private *priv)
+{
+	u32 val = priv->tx_desc_addr;
+
+	__raw_writel(val, priv->iomem + ETH_TX_DMA_ADDR);
+}
+
+static int cn100_hw_rx(struct cn100_private *priv, int budget)
+{
+	struct net_device *dev = priv->netdev;
+	struct rx_unit *unit;
+	struct sk_buff *skb;
+	u32 read_ptr, pkt_size;
+	int received = 0;
+
+	while (netif_running(dev) && received < budget) {
+
+		read_ptr = __raw_readl(priv->iomem + ETH_RX_RD_ADDR);
+		if (read_ptr & ETH_FIFO_EMPTY)
+			break;
+
+		unit = priv->rx_fifo_p[read_ptr & ETH_FIFO_MASK];
+		pkt_size = be32_to_cpu(unit->size) - 4; // Exclude CRC
+
+		if (pkt_size <= RX_ITEM_SIZE) {
+			/* Copy packet to skb_buff */
+			skb = dev_alloc_skb(pkt_size);
+			if (likely(skb)) {
+				skb_put(skb, pkt_size);
+				memcpy(skb->data, unit->packet, pkt_size);
+				skb->protocol = eth_type_trans(skb, dev);
+				netif_receive_skb(skb);
+
+				dev->stats.rx_bytes += pkt_size;
+				dev->stats.rx_packets++;
+			} else
+				dev->stats.rx_dropped++;
+		}
+
+		received++;
+		read_ptr++;
+
+		if ((read_ptr & ETH_FIFO_MASK) == priv->rx_fifo_num)
+			read_ptr = (~read_ptr) & ETH_FIFO_TOG;;
+
+		__raw_writel(read_ptr, priv->iomem + ETH_RX_RD_ADDR);
+	}
+
+	return received;
+}
+
+static void cn100_hw_set_dma(struct cn100_private *priv)
+{
+	dma_addr_t dma_addr = priv->dma_addr;
+	void __iomem *dma_area = priv->dma_area;
+	int i;
+
+	priv->tx_desc_addr = dma_addr;
+	priv->tx_data_area = dma_area + sizeof(struct tx_desc);
+
+	priv->tx_desc_p = (struct tx_desc *)dma_area;
+	priv->tx_desc_p->buffer_addr = cpu_to_be32(dma_addr + sizeof(struct tx_desc));
+	priv->tx_desc_p->buffer_len = 0;
+	priv->tx_desc_p->next_link_item = 0;
+	priv->tx_desc_p->next_item_valid_flag = 0;
+
+	dma_addr += TX_ITEM_SIZE + sizeof(struct tx_desc);
+	dma_area += TX_ITEM_SIZE + sizeof(struct tx_desc);
+
+
+	/* init rx buffer struct */
+	priv->rx_fifo_addr = dma_addr;
+	priv->rx_fifo_num = (priv->dma_size - (dma_addr - priv->dma_addr)) / RX_ITEM_SIZE;
+	if (priv->rx_fifo_num > RX_ITEM_MAX)
+		priv->rx_fifo_num = RX_ITEM_MAX;
+	for (i = 0; i < priv->rx_fifo_num; i++) {
+		priv->rx_fifo_p[i] = (struct rx_unit *)dma_area;
+		dma_area += RX_ITEM_SIZE;
+	}
+
+	DEBUG("Ethernet DMA Unit RX %d\n", priv->rx_fifo_num);
+	DEBUG("Tx desc: %x\n", priv->tx_desc_addr);
+	DEBUG("Rx fifo: %x\n", priv->rx_fifo_addr);
+}
+
+static void cn100_hw_tx_desc_add(struct sk_buff *skb, struct net_device *dev)
+{
+	struct cn100_private *priv = (struct cn100_private *)netdev_priv(dev);
+
+	memcpy(priv->tx_data_area, skb->data, skb->len);
+	dma_map_single(NULL, priv->tx_data_area, skb->len, DMA_TO_DEVICE);
+
+	priv->tx_desc_p->buffer_len = cpu_to_be32(skb->len);
+
+	dev->stats.tx_packets ++;
+	dev->stats.tx_bytes += skb->len;
+	dev_kfree_skb(skb);
+}
+
+static irqreturn_t cn100_interrupt(int irq, void *dev_id)
+{
+	struct net_device *dev = dev_id;
+	struct cn100_private *priv = netdev_priv(dev);
+	int status = __raw_readl(priv->iomem + ETH_INT_REG_ADDR);
+
+	// Fix HW FIFO BUG
+	if (status & ETH_INT_HALF) {
+		u32	ptr = __raw_readl(priv->iomem + ETH_RX_WR_ADDR);
+
+		DEBUG("Int Half Full\n");
+		__raw_writel(ETH_INT_HALF, priv->iomem + ETH_INT_CLS_ADDR);
+		__raw_writel(ptr, priv->iomem + ETH_RX_RD_ADDR);
+	}
+
+	if (status & ETH_INT_RX) {
+		DEBUG("Int RX\n");
+		__raw_writel(ETH_INT_RX, priv->iomem + ETH_INT_CLS_ADDR);
+
+		napi_schedule(&priv->napi);
+	}
+
+	if (status & ETH_INT_TX) {
+		DEBUG("Int TX\n");
+		__raw_writel(ETH_INT_TX, priv->iomem + ETH_INT_CLS_ADDR);
+
+		netif_wake_queue(dev);
+	}
+
+	return IRQ_HANDLED;
+}
+
+static void cn100_set_rx_mode(struct net_device *dev)
+{
+	struct cn100_private *priv = netdev_priv(dev);
+	u32 hash[2] = { 0, 0 };
+	u32 mask = 0;
+
+	if (dev->flags & IFF_PROMISC)
+		mask |= 0x04;
+
+	if (dev->flags & IFF_BROADCAST)
+		mask |= 0x01;
+
+	if (dev->flags & IFF_MULTICAST) {
+		mask |= 0x02;
+
+		if (dev->flags & IFF_ALLMULTI) {
+			hash[0] = 0xFFFFFFFF;
+			hash[1] = 0xFFFFFFFF;
+		} else {
+			struct netdev_hw_addr *ha;
+
+			netdev_for_each_mc_addr(ha, dev) {
+				u32 crc = ether_crc(ETH_ALEN, ha->addr);
+				int bit = (crc >> 26) & 0x3F;
+				hash[bit >> 5] |= 1 << (bit & 0x1F);
+			}
+		}
+	}
+
+	DEBUG("Rx mode %x %x %x\n", mask, hash[0], hash[1]);
+
+	__raw_writel(mask, priv->iomem + ETH_MAC_SA_MASK);
+	__raw_writel(hash[0], priv->iomem + ETH_MAC_HASH_TAB0);
+	__raw_writel(hash[1], priv->iomem + ETH_MAC_HASH_TAB1);
+}
+
+static void cn100_timer(unsigned long data)
+{
+	struct net_device *dev = (struct net_device *)data;
+	struct cn100_private *priv = netdev_priv(dev);
+
+	if (mii_check_media(&priv->mii, true, false)) {
+		int full = priv->mii.full_duplex;
+		__raw_writel(full ? 0x00B3 : 0x00B2, priv->iomem + ETH_MAC_CFG1);
+	}
+
+	priv->timer.expires = jiffies + (HZ << 1);
+	add_timer(&priv->timer);
+}
+
+static int cn100_open(struct net_device *dev)
+{
+	struct cn100_private *priv = netdev_priv(dev);
+	int nt = priv->shift;
+	int ret, id;
+
+	DEBUG("--> %s\n", __func__);
+
+	cn100_hw_open(priv);
+	cn100_hw_set_dma(priv);
+
+	if (mii_check_media(&priv->mii, true, true)) {
+		int full = priv->mii.full_duplex;
+		__raw_writel(full ? 0x00B3 : 0x00B2, priv->iomem + ETH_MAC_CFG1);
+	}
+
+	cn100_set_rx_mode(dev);
+
+	/* add intterrupt request */
+	napi_enable(&priv->napi);
+	ret = request_irq(dev->irq, cn100_interrupt, IRQF_SHARED, dev->name, dev);
+	if (ret < 0) {
+		napi_disable(&priv->napi);
+		cn100_hw_close(priv);
+		return -EAGAIN;
+	}
+
+	cn100_hw_start(priv);
+	netif_start_queue(dev);
+
+	for (id = 0; id < 32; id++) {
+		ret = priv->mii.mdio_read(dev, id, MII_BMSR);
+		if (ret != 0xffff && ret != 0x0000) {
+			if (nt) {
+				nt = 0;
+				continue;
+			}
+
+			priv->mii.phy_id = id;
+			printk(KERN_INFO "CSM CN100 %s: MII ID %d\n", dev->name, id);
+			break;
+		}
+	}
+
+	init_timer(&priv->timer);
+	priv->timer.expires = jiffies + (HZ << 1);
+	priv->timer.data = (unsigned long)dev;
+	priv->timer.function = cn100_timer;
+	add_timer(&priv->timer);
+	return 0;
+}
+
+static int cn100_close(struct net_device *dev)
+{
+	struct cn100_private *priv = (struct cn100_private *)netdev_priv(dev);
+
+	DEBUG("--> %s\n", __func__);
+
+	netif_stop_queue(dev);
+	napi_disable(&priv->napi);
+	free_irq(dev->irq, dev);
+
+	del_timer_sync(&priv->timer);
+	cn100_hw_close(priv);
+	return 0;
+}
+
+static netdev_tx_t cn100_start_xmit(struct sk_buff *skb, struct net_device *dev)
+{
+	struct cn100_private *priv = (struct cn100_private *)netdev_priv(dev);
+
+	netif_stop_queue(dev);
+
+	spin_lock(&priv->tx_lock);
+
+	if( cvm_on_before_skb_tx )
+	{
+		cvm_on_before_skb_tx( dev, NULL );
+	}
+
+	cn100_hw_tx_desc_add(skb, dev);
+
+	dev->trans_start = jiffies;
+
+	cn100_hw_tx(priv);
+
+	if( cvm_on_skb_tx_done )
+	{
+		cvm_on_skb_tx_done( dev, NULL );
+	}
+
+	spin_unlock(&priv->tx_lock);
+	return NETDEV_TX_OK;
+}
+
+static int cn100_poll(struct napi_struct *napi, int budget)
+{
+	struct cn100_private *priv = container_of(napi, struct cn100_private, napi);
+	int work_done = 0;
+	u32 ptr;
+
+	spin_lock(&priv->rx_lock);
+
+rx_action:
+
+	work_done += cn100_hw_rx(priv, budget - work_done);
+	ptr = __raw_readl(priv->iomem + ETH_RX_RD_ADDR);
+
+	if (work_done < budget) {
+		if (ptr & ETH_FIFO_EMPTY)
+			__napi_complete(napi);
+		else
+			goto rx_action;
+	}
+
+	if (ptr & ETH_FIFO_EMPTY)
+		__raw_writel(ETH_INT_RX, priv->iomem + ETH_INT_CLS_ADDR);
+
+	spin_unlock(&priv->rx_lock);
+
+	return work_done;
+}
+
+static const struct net_device_ops cn100_netdev_ops = {
+	.ndo_open = cn100_open,
+	.ndo_stop = cn100_close,
+	.ndo_start_xmit = cn100_start_xmit,
+	.ndo_set_rx_mode = cn100_set_rx_mode,
+	.ndo_set_mac_address = cn100_set_mac_address,
+	.ndo_do_ioctl = netdev_ioctl,
+	.ndo_change_mtu = eth_change_mtu,
+};
+
+static int cn100_phy_read(struct net_device *dev, int phy_id, int reg)
+{
+	struct cn100_private *priv = (struct cn100_private *)netdev_priv(dev);
+	__raw_writel(0x00, priv->iomem + ETH_MAC_MCMD);
+
+	__raw_writel((phy_id << 8) | reg, priv->iomem + ETH_MAC_MADR);
+	__raw_writel(0x01, priv->iomem + ETH_MAC_MCMD);
+
+	while (__raw_readl(priv->iomem + ETH_MAC_MIND) & 0x01);
+	return __raw_readl(priv->iomem + ETH_MAC_MRDD);
+}
+
+static void cn100_phy_write(struct net_device *dev, int phy_id, int reg, int value)
+{
+	struct cn100_private *priv = (struct cn100_private *) netdev_priv(dev);
+
+	__raw_writel((phy_id << 8) | reg, priv->iomem + ETH_MAC_MADR);
+	__raw_writel(value, priv->iomem + ETH_MAC_MWTD);
+
+	while (__raw_readl(priv->iomem + ETH_MAC_MIND) & 0x01);
+}
+
+static u64 dma_mask = DMA_BIT_MASK(32);
+
+static int __devinit cn100_probe(struct platform_device *pdev)
+{
+	struct net_device *netdev;
+	struct cn100_private *priv;
+	struct resource *memres, *irqres;
+	struct device *dev;
+
+	DEBUG("--> %s\n", __func__);
+
+	/* Enable clock */
+	clock_xport_enaclock(_clock_enable);
+
+	/* Alloc network device object and init it */
+	netdev = alloc_etherdev(sizeof(struct cn100_private));
+	if (!netdev)
+		return -ENOMEM;
+
+	SET_NETDEV_DEV(netdev, &pdev->dev);
+	platform_set_drvdata(pdev, netdev);
+
+	memres = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (!memres)
+		return -ENXIO;
+
+	netdev->base_addr = (unsigned long)ioremap(memres->start, resource_size(memres));
+	if (!netdev->base_addr)
+		return -EBUSY;
+
+	irqres = platform_get_resource(pdev, IORESOURCE_IRQ, 0);
+	if (!irqres)
+		return -ENXIO;
+
+	netdev->irq	= irqres->start;
+
+	ether_setup(netdev);
+
+	/* setup driver-private data */
+	priv = netdev_priv(netdev);
+	priv->netdev = netdev;
+
+	dev = &netdev->dev;
+	if (!dev->dma_mask)
+		dev->dma_mask = &dma_mask;
+	if (!dev->coherent_dma_mask)
+		dev->coherent_dma_mask = DMA_BIT_MASK(32);
+
+	priv->dma_size = SZ_512K;
+	priv->dma_area = dma_alloc_coherent(dev, priv->dma_size, &priv->dma_addr, GFP_KERNEL);
+	if (!priv->dma_area)
+		return -ENOMEM;
+
+	priv->iomem = (void *)netdev->base_addr;
+
+	if (pdev->id > 0) {
+		priv->shift = 16;
+		priv->ctl_offset = ETH1_CTL_BASE - ETH0_CTL_BASE;
+		priv->mac_offset = ETH1_MAC_BASE - ETH0_MAC_BASE;
+	}
+
+	cn100_hw_close(priv);
+
+	spin_lock_init(&priv->lock);
+	spin_lock_init(&priv->tx_lock);
+	spin_lock_init(&priv->rx_lock);
+
+	netdev->ethtool_ops = &netdev_ethtool_ops;
+	netdev->netdev_ops = &cn100_netdev_ops;
+
+	netif_napi_add(netdev, &priv->napi, cn100_poll, 8);
+
+	priv->mii.dev = netdev;
+	priv->mii.mdio_read = cn100_phy_read;
+	priv->mii.mdio_write = cn100_phy_write;
+	priv->mii.full_duplex = 1;
+	priv->mii.phy_id_mask = 0x1F;
+	priv->mii.reg_num_mask = 0x1F;
+
+	cn100_hw_set_addr(pdev->id > 0 ? MacAddr1 : MacAddr, priv);
+	memcpy(netdev->dev_addr, pdev->id > 0 ? MacAddr1 : MacAddr, ETH_ALEN);
+
+	eth_proc_init();
+
+	return register_netdev(netdev);
+}
+
+static int __devexit cn100_remove(struct platform_device *pdev)
+{
+	struct net_device *dev = platform_get_drvdata(pdev);
+	struct cn100_private *priv = netdev_priv(dev);
+
+	remove_proc_entry("eth0", NULL);
+	remove_proc_entry("eth1", NULL);
+
+	platform_set_drvdata(pdev, NULL);
+
+	if (dev) {
+		free_irq(dev->irq, dev);
+		netif_napi_del(&priv->napi);
+
+		unregister_netdev(dev);
+		free_netdev(dev);
+		cn100_hw_close(priv);
+	}
+
+	return 0;
+}
+
+static struct platform_driver cn100_driver = {
+	.driver  = {
+		.name = "cnc-eth",
+		.owner = THIS_MODULE,
+	},
+	.probe   = cn100_probe,
+	.remove  = __devexit_p(cn100_remove),
+};
+
+module_platform_driver(cn100_driver);
+
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("Celestial CN100 MAC Driver");
+
+static int __init setup_mac(char *str)
+{
+	char *p = str;
+	int i;
+
+	if (p != NULL && *p != '\0') {
+		printk("CSM ETH Get MAC: %s\n", p);
+		for (i = 0; i < sizeof(MacAddr); i++) {
+			MacAddr[i] = simple_strtoul(p, &p, 16);
+			MacAddr1[i] = MacAddr[i];
+			p++;
+		}
+		MacAddr1[5]++;
+	}
+	return 0;
+}
+__setup("ethaddr=", setup_mac);
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/peripheral/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/peripheral/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/peripheral/Kconfig	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/peripheral/Kconfig	2014-10-23 20:22:19.978715000 +0800
@@ -0,0 +1,112 @@
+#
+# Character device configuration
+#
+
+if ARCH_CELESTIAL 
+menu "Celestial Peripheral Devices"
+
+config CELESTIAL_NAND
+	tristate "NAND Flash Controller(based SMC)"
+	depends on MTD_NAND
+	help
+	  Include support drvier for NAND of celestial platform
+
+config CELESTIAL_ETH
+	bool "CN100 MAC Controller"
+	depends on NET
+	help
+	  Include support drvier for ETH of celestial platform
+
+config CELESTIAL_MULT_ETH
+	bool "Support Mult ETH"
+	depends on CELESTIAL_ETH
+
+config CELESTIAL_SPI
+	bool "SPI Host Controller(based DesignWare IP)"
+	depends on SPI_MASTER
+	select SPI_DESIGNWARE
+	select SPI_DW_MMIO
+	help
+	  Include support drvier for SPI Host of celestial platform
+
+config CELESTIAL_UART1
+	bool "Enable UART1"
+
+config CELESTIAL_UART1_CTS_RTS
+	bool "Enable Hardware CTS/RTS"
+	depends on CELESTIAL_UART1
+
+config CELESTIAL_MMC
+	bool "MMC Host Controller(based DesignWare IP)"
+	depends on MMC
+	select MMC_DW
+	select MMC_DW_IDMAC
+	select MMC_DW_PLTFM
+	help
+	  Include support drvier for MMC Host of celestial platform
+
+config CELESTIAL_MULT_MMC
+	bool "Support Mult SD Card"
+	depends on CELESTIAL_MMC
+
+config CELESTIAL_8BIT_MMC
+	bool "Support 8Bit MMC Card"
+	depends on CELESTIAL_MMC && !CELESTIAL_MULT_MMC
+
+config CELESTIAL_HCI
+	bool "USB OHCI/EHCI Controller"
+	depends on USB
+	select USB_OHCI_HCD
+	select USB_OHCI_HCD_PLATFORM
+	select USB_EHCI_HCD
+	select USB_EHCI_HCD_PLATFORM
+	help
+	  Include support drvier for USB Host of celestial platform
+
+config CELESTIAL_OTG
+	bool "USB OTG Controller(based DesignWare IP)"
+	depends on USB
+	select USB_GADGET_DUALSPEED
+	help
+	  Include support drvier for USB OTG of celestial platform
+
+config CELESTIAL_I2C
+	bool "I2C Host Controller"
+	depends on I2C
+	help
+	  Include support drvier for I2C Host of celestial platform
+
+config CELESTIAL_SCI
+	bool "Smart Card"
+	help 
+	  Include support drvier for smartcard of celestial platform
+
+config CELESTIAL_GPIO
+	bool "GPIO driver"
+	help
+	  Include support drvier for GPIO of celestial platform
+
+config CELESTIAL_FPC
+	bool "FPC driver"
+	help
+	  Include support drvier for FPC of celestial platform
+
+config CELESTIAL_FPC_IR_GPIO
+	int "GPIO# for FPC IR receiver"
+	depends on CELESTIAL_FPC
+	default 11
+	help
+	  GPIO number (0~15) for FPC IR Receiver connection
+
+config CELESTIAL_SEC
+	bool "Secure driver"
+	help
+	  Include support drvier for Secure id of celestial platform
+
+config VGA_SWITCHER_SUPPORT
+	bool "vga switcher"
+	help 
+	  Support VGA Switcher Function by using GPIO interrupt
+
+endmenu
+endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/peripheral/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/peripheral/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/peripheral/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/peripheral/Makefile	2014-10-23 20:22:19.978715000 +0800
@@ -0,0 +1,13 @@
+#
+# Makefile for the linux kernel.
+#
+
+ifdef CONFIG_ARCH_CELESTIAL
+obj-$(CONFIG_CELESTIAL_NAND) += cnc1900_nand.o
+obj-$(CONFIG_CELESTIAL_ETH)  += eth.o
+obj-$(CONFIG_CELESTIAL_I2C)  += cnc1900_i2c.o
+obj-$(CONFIG_CELESTIAL_SCI)  += cnc18xx_sci.o
+obj-$(CONFIG_CELESTIAL_GPIO) += cnc1900_gpio.o
+obj-$(CONFIG_CELESTIAL_FPC)  += cnc1900_fpc.o
+obj-$(CONFIG_CELESTIAL_SEC)  += cnc18xx_sec.o
+endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/peripheral/vga_switcher.c linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/peripheral/vga_switcher.c
